const YesNoNode = require('../YesNoNode');
const UseAbility = require('../UseAbility');
const Q_has_option = require('./Q_has_option');
const BattleCalc = require('../../BattleCalc');

const AttackerBuffDecision = function(actor, battleState, fullyBuffedCaseNode) {
  const node = new YesNoNode(actor, battleState);

  node.branches[node.YES] = new Q_has_option(actor, battleState, fullyBuffedCaseNode);

  if (BattleCalc.getEquippedAbility(actor,'bless')) {
    node.branches[node.NO] = new UseAbility(actor, 'bless', actor);
  } else {
    node.branches[node.NO] = node.branches[node.YES];
  }

  node.yesNoEvalFunction = function() {
    return BattleCalc.getCondition(actor, 'blessed');
  };

  return node;
};
module.exports = AttackerBuffDecision;
