/**
 * ...
 * @author Robert Lombardo, Wakefield Studios ( rob@wakefield-studios.com )
 */
const TreeNode = require('../TreeNode');
const UseAbility = require('../UseAbility');
const BattleCalc = require('../../BattleCalc');

const Q_which_aoe_attack = function (
  actor,
  battleState,
  noAOEAbilitiesCaseNode
) {
  const node = new TreeNode(actor, battleState, noAOEAbilitiesCaseNode);

  // branch indexes
  node.ROUNDHOUSE = 0;
  node.FUMIGATE = 1;
  node.LIGHTNING = 2;

  node.branches[node.ROUNDHOUSE] = new UseAbility(actor, 'roundhouse');
  node.branches[node.FUMIGATE] = new UseAbility(actor, 'fumigate');
  node.branches[node.LIGHTNING] = new UseAbility(actor, 'lightning');

  node.query = function () {
    var _chance = Math.floor(Math.random() * this.branches.length);

    if (
      _chance === this.ROUNDHOUSE &&
      BattleCalc.getEquippedAbility(this.actor, 'roundhouse')
    ) {
      return this.branches[this.ROUNDHOUSE].query(this.actor);
    } else if (
      _chance === this.FUMIGATE &&
      BattleCalc.getEquippedAbility(this.actor, 'fumigate')
    ) {
      return this.branches[this.FUMIGATE].query(this.actor);
    } else if (
      _chance === this.LIGHTNING &&
      BattleCalc.getEquippedAbility(this.actor, 'lightning')
    ) {
      return this.branches[this.LIGHTNING].query(
        this.battleState.getNearestEnemyOf(this.actor)
      );
    } else {
      return this.altNode.query(); // _altnode should be set to Q_state_of_best_target (we go for a single target attack)
    }
  };

  return node;
};
module.exports = Q_which_aoe_attack;
