/**
 * ...
 * @author Robert Lombardo, Wakefield Studios ( rob@wakefield-studios.com )
 */
const Q_buff_ally = require('./Q_buff_ally');
const Q_full_AP = require('./Q_full_AP');
const UseAbility = require('../UseAbility');
const BattleCalc = require('../../BattleCalc');

const Q_ally_no_poisoner = function (actor, battleState) {
  const node = new Q_buff_ally('poison_weapon', actor, battleState);

  node.branches[node.NO] = new Q_full_AP(actor, battleState);
  node.branches[node.YES] = new UseAbility(actor, 'poison_weapon');

  node.getUnitWithoutBuff = function () {
    for (var prop in this.battleState.allUnits) {
      var unit = this.battleState.allUnits[prop];
      if (
        unit.team === this.actor.team &&
        BattleCalc.boardDistance(this.actor, unit) < 3 &&
        !BattleCalc.getCondition(unit, this.buffCondition)
      ) {
        return unit;
      }
    }

    return null;
  };

  return node;
};
module.exports = Q_ally_no_poisoner;
