const YesNoNode = require('../YesNoNode');
const TreeNode = require('../TreeNode');

const Q_any_enemies = function(actor, battleState, moveTowards) {
  const node = new YesNoNode(actor, battleState);

  node.branches[ node.NO ] = new TreeNode(null, null);

  if (actor.ai.settings.autoMove) {
    node.branches[ node.YES ] = moveTowards;
  } else {
    node.branches[ node.YES ] = node.branches[ node.NO ];
  }

  node.query = function() {
    if (this.yesNoEvalFunction()) {
      return this.branches[this.YES].query(
        this.battleState.getNearestEnemyOf(this.actor)
      );
    } else {
      return null;
    }
  };

  node.yesNoEvalFunction = function()	{
    return this.battleState.getEnemiesOfUnit(this.actor).length > 0;
  };

  return node;
};
module.exports = Q_any_enemies;
